unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdHTTP;

type
  TForm1 = class(TForm)
    Image1: TImage;
    IdHTTP1: TIdHTTP;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Image2: TImage;
    Button1: TButton;
    Label3: TLabel;
    Timer1: TTimer;
    procedure imageRedraw;
    function startGame:string;
    procedure drawObject(x,y:integer;typ:char);
    function downloadData(const data:string):string;
    procedure drawMap;
    procedure drawTahy;
    procedure FormCreate(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure LabeledEdit2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure drawRobot(def:boolean=true);
    procedure drawTextObject(x,y:integer;znak:char);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
type
  mapa=array[1..20,1..20]of char;
  TTah=record
    znak:char;
    selected:byte;
  end;

const
CELL_WIDTH=16;
CELL_HEIGHT=16;
TAH_CELL=30;
IMAGE_WIDTH=CELL_WIDTH*20;
IMAGE_HEIGHT=CELL_HEIGHT*20;
DEFAULT_ADDRESS='127.0.0.1';
DEFAULT_PORT=8000;

var
  Form1: TForm1;
  addr:string = DEFAULT_ADDRESS;
  port:integer = DEFAULT_PORT;
  gameID:integer;
  gameMapa:mapa;
  robot:TPoint;
  robotD:char;

  tahy:array[1..9] of TTah;
  selectCount:byte=0;
  robotT:tpoint;
  robotDT:char;
  drawnTah:integer;
  countTah:integer;

implementation

{$R *.dfm}

procedure TForm1.drawObject(x,y:integer;typ:char);
begin

  with image1.canvas do
    begin
        case typ of
        'X':begin
          brush.Color:=clBlack;
          pen.color:=clBlack;
          rectangle((x-1)*CELL_WIDTH,(y-1)*CELL_HEIGHT,x*CELL_WIDTH,y*CELL_HEIGHT);
          end;
        '#':begin
  
//          pen.color:=clBlack;
//          rectangle((x-1)*CELL_WIDTH,(y-1)*CELL_HEIGHT,x*CELL_WIDTH,y*CELL_HEIGHT);
          brush.Color:=clGray;
          ellipse((x-1)*CELL_WIDTH,(y-1)*CELL_HEIGHT,x*CELL_WIDTH,y*CELL_HEIGHT);
          end;
        '$':begin
          brush.Color:=clYellow;
          pen.color:=clYellow;
          rectangle((x-1)*CELL_WIDTH,(y-1)*CELL_HEIGHT,x*CELL_WIDTH,y*CELL_HEIGHT);
        end;
        '.': else
          begin
             drawTextObject(x,y,typ);
          end;
        end

    end;
end;


procedure TForm1.drawTextObject(x,y:integer;znak:char);
begin
  with image1.canvas do
    begin
      pen.color:=clBlack;
      brush.color:=clWhite;
      TextOut((x-1)*CELL_WIDTH+3,(y-1)*CELL_HEIGHT+3,znak);
    end;
end;


function TForm1.startGame:string;
begin
  try
   result:=idhttp1.get('http://'+addr+':'+inttostr(port)+'/start');
  except
   on e:exception do showmessage('Problm s pipojenm, zkuste to prosm pozdji');
  end;
end;

procedure winGame(s:string);
begin

    showmessage(s+chr(13)+chr(10)+'Hra bude restartovna');
    form1.Button2.click;
end;

function TForm1.downloadData(const data:string):string;
begin
    try
      result:=idhttp1.get('http://'+addr+':'+inttostr(port)+'/kolo?'+data);
     except
       on e:exception do showmessage('Problm s pipojenm, zkuste to prosm pozdji');
   end;
end;

function obsahuje(haystack:string;needle:string):boolean;
  var
    i:byte;
begin
  result:=true;
  for i:=1 to length(needle) do
  if haystack[i]<>needle[i] then
    begin
      result:=false;
      exit;
    end;
end;
procedure setRobotX(x:string);
begin
  robot.X:=strToInt(x);
end;

procedure setRobotY(y:string);
begin
  robot.Y:=strToInt(y);
end;



procedure setGameId(s:string);
  begin
    gameID:=strToInt(s);
    form1.Label2.Caption:=s;
  end;
 
procedure setTahy(r:string);
var
i:byte;
begin
  for i:=1 to 9 do
    begin
      with tahy[i] do
        begin
          selected:=0;
          znak:=r[i];
        end;
      end;
end;



procedure parseData(inp:string;var id:integer;var map:mapa);
var
  x,y,i:integer;
  buff:string;
  pos:byte;
  written:boolean;
begin
  buff:='';
  written:=false;
  pos:=0;
if (obsahuje(inp,'Chyba')) then
  begin
    showmessage(inp+chr(13)+chr(10)+'Hra bude restartovna');
    form1.button2.click;
    exit;
  end;

  if (obsahuje(inp,'Vyhrali')) then
  begin
    winGame(inp);

    exit;
  end;

y:=0;
x:=0;
for i:=1 to length(inp) do
  begin
    if inp[i]=chr(13) then continue;
    if inp[i]=chr(10) then begin
      y:=y+1;
      continue;
    end;
    if (y=0) then
      begin
        buff:=buff+inp[i];
        written:=false;
      end;
    if (y=1) and (not written) then
      begin
        setGameId(buff);
        written:=true;
      end;

  if (y>=1) and (y<=20) then
    begin
      x:=x+1;
      if x>20 then x:=1;
      map[x,y]:=inp[i];
    end;

  if (y=20) then buff:='';

   if (y=21) then
    begin
    written:=false;
      if (inp[i]=' ') then begin
      pos:=pos+1;
        case pos of
          1:setRobotX(buff);
          2:setRobotY(buff);
        end;
        buff:='';
        continue;
      end;
      buff:=buff+inp[i];
    end;

  if (y=22) and (not written) then
  begin
    robotD:=buff[1];
    written:=true;
    buff:='';
  end;

  if (y=22) then
  buff:=buff+inp[i];
  end;
  setTahy(buff);
end;

procedure TForm1.imageRedraw;
var
  x,y:integer;
begin
    x:=0;
    y:=0;

    with image1 do begin
    canvas.Brush.Color:=clWhite;
        canvas.pen.Color:=clBlack;
    canvas.FillRect(image1.Canvas.ClipRect);
while (x<IMAGE_WIDTH) do
      begin
        x:=x+CELL_WIDTH;
        canvas.moveTo(x,0);
        canvas.lineTo(x,IMAGE_HEIGHT);
      end;
while (y<IMAGE_height) do
      begin

                y:=y+CELL_HEIGHT;
        canvas.moveTo(0,y);
        canvas.lineTo(IMAGE_WIDTH,y);
      end;


    end;

end;
procedure TForm1.FormCreate(Sender: TObject);
begin
with image1 do
  begin
    width:=IMAGE_WIDTH;
    height:=IMAGE_HEIGHT;
  end;
with image2 do
  begin
    width:=TAH_CELL*9;
    height:=TAH_CELL;
  end;
labelededit1.Text:=DEFAULT_ADDRESS;
labelededit2.text:=inttostr(DEFAULT_PORT);

imageRedraw;
end;

procedure TForm1.LabeledEdit1Change(Sender: TObject);
begin
  addr:=labeledEdit1.Text;
end;

procedure TForm1.LabeledEdit2Change(Sender: TObject);

begin
button2.Enabled:=true;
try
  port:=strtoint(labeledEdit2.Text);
  except
  on e:exception do button2.Enabled:=false;
  end;

end;



procedure TForm1.drawRobot(def:boolean=true);
var
  r:TPoint;
begin
if def=true then r:=robot else r:=robotT;
  with image1 do
    begin
      canvas.Pen.Color:=clRed;
if def then
      canvas.Brush.Color:=clGreen else
            canvas.Brush.Color:=clYellow;
      canvas.Rectangle(CELL_WIDTH*(r.x-1),CELL_HEIGHT*(r.y-1),CELL_WIDTH*r.x,CELL_HEIGHT*r.y);
if def then
      canvas.TextOut(CELL_WIDTH*(r.x-1)+2,CELL_HEIGHT*(r.y-1)+2,robotD) else
            canvas.TextOut(CELL_WIDTH*(r.x-1)+2,CELL_HEIGHT*(r.y-1)+2,robotDT);
    end;
  end;
procedure TForm1.drawMap;
var
x,y:integer;
begin
for y:=1 to 20 do
  for x:=1 to 20 do
    begin
            form1.drawObject(x,y,gameMapa[x,y]);
    end;
drawRobot;
end;

procedure TForm1.drawTahy;
var i:byte;
begin
with   image2 do
  begin
  canvas.brush.Color:=clWhite;
  canvas.pen.color:=clWhite;
  canvas.FillRect(canvas.clipRect);
    canvas.Brush.Style:=bsSolid;



    for i:=1 to 9 do
      begin
        if tahy[i].selected>0 then
        begin
          canvas.Pen.Color:=clYellow;
          canvas.Brush.Color:=clYellow;
          canvas.Rectangle((i-1)*TAH_CELL,0,i*TAH_CELL,TAH_CELL);
          Canvas.Font.Size:=6;

          Canvas.TextOut((i)*TAH_CELL-10,1,inttostr(tahy[i].selected)+'.');
        end else
        begin
          canvas.Brush.Color:=clWhite;
          canvas.Pen.Color:=clWhite;
        end;
        Canvas.Font.Size:=20;
          canvas.Brush.Style:=bsClear;
        Canvas.TextOut((i-1)*TAH_CELL,1,tahy[i].znak);
      end;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
  var
    res:string;
begin
imageRedraw;
res:=startGame;

parseData(res,gameID,gameMapa);
drawMap;
drawTahy;
selectCount:=0;
button1.enabled:=false;
end;

procedure odeslatTahy;
var i:byte;
d:string;
res:string;
begin
d:='     ';
for i:=1 to 9 do
  begin
    if tahy[i].selected>0 then
    d[tahy[i].selected]:=tahy[i].znak;
  end;
  with form1 do begin
  imageRedraw;
res:=form1.downloadData('id='+inttostr(gameID)+'&pohyby='+d);
//res:=startGame;

parseData(res,gameID,gameMapa);
drawMap;
drawTahy;
selectCount:= 0;
button1.Enabled:=false;
end;
end;

procedure displayTahy(c:integer);
begin
  countTah:=c;
  drawnTah:=0;
  robotDT:=robotD;
  with form1 do
    begin
      timer1.Enabled:=true;
      timer1.Interval:=1;
      drawRobot(false);
    end;
end;


procedure TForm1.Image2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
  var
    pos:integer;
    i:byte;
    change:shortint;
  begin

      pos:=x div TAH_CELL+1;
if (selectCount<5) then
  begin


    if (    tahy[pos].selected=0) then
      begin
          selectCount:=selectCount+1;
        tahy[pos].selected:=selectCount;

      end;
    drawTahy;
    end else
    if ((button=mbRight)or(button=mbLeft)) then
    begin
    if ((button=mbRight)) then
    change:=-1 else change:=1;
      if ((tahy[pos].selected>1)or (button=mbLeft)) then
     for i:=1 to 9 do
    if tahy[i].selected=(tahy[pos].selected+change) then
      begin
        tahy[i].selected:=tahy[i].selected-change;
        tahy[pos].selected:=        tahy[pos].selected+change;
                break;
      end;
    end;
  if selectcount=5 then
  begin
//  odeslatTahy;
   if (button=mbMiddle) then
      begin
        robotT:=robot;
        displayTahy(tahy[pos].selected);

      end;

  button1.Enabled:=true;
  end;
drawTahy;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
timer1.Enabled:=false;
  odeslatTahy;
end;


function testGoX(l:shortint):shortint;
var
i:shortint;
begin
//
if (l>0) then
  begin
    for i:=0 to l do
    if gameMapa[robott.X+i,robott.Y]='X' then break;
  end;

if (l<0) then
  begin
    for i:=0 downto l do
    if gameMapa[robott.X+i,robott.Y]='X' then break;
  end;
result:=i;
end;

  
function testGoY(l:shortint):shortint;
var
i:shortint;
begin
//
if (l>0) then
  begin
    for i:=0 to l do
    if gameMapa[robott.X,robott.Y+i]='X' then break;
  end;

if (l<0) then
  begin
    for i:=0 downto l do
    if gameMapa[robott.X,robott.Y+i]='X' then break;
  end;
result:=i;
end;


procedure TForm1.Timer1Timer(Sender: TObject);
var i:byte;
displ:boolean;
begin
displ:=false;
timer1.Interval:=500;
  drawnTah:=drawnTah+1;
  if drawnTah>=countTah then
  begin
   timer1.Enabled:=false;
  end;
  for i:=1 to 9 do
    begin
      if (tahy[i].selected=drawnTah) and (tahy[i].selected<>0) then
      begin
          case tahy[i].znak of
          '1':case robotDT of
              'N':robotT.Y:=robotT.Y-1;
              'D':robotT.Y:=robotT.Y+1;
              'L':robotT.x:=robotT.x-1;
              'R':robotT.x:=robotT.x+1;
            end;
           '2':case robotDT of
              'N':robotT.Y:=robotT.Y-2;
              'D':robotT.Y:=robotT.Y+2;
              'L':robotT.x:=robotT.x-2;
              'R':robotT.x:=robotT.x-2;
            end;

          '3':case robotDT of
              'N':robotT.Y:=robotT.Y-3;
              'D':robotT.Y:=robotT.Y+3;
              'L':robotT.x:=robotT.x-3;
              'R':robotT.x:=robotT.x+3;
            end;
          'L':case robotDT of
              'L':ROBOTDT:='D';
              'D':ROBOTDT:='R';
              'R':ROBOTDT:='N';
              'N':ROBOTDT:='L';
            end;
          'R':case robotDT of
              'L':ROBOTDT:='N';
              'D':ROBOTDT:='L';
              'R':ROBOTDT:='D';
              'N':ROBOTDT:='R';
            end;
           'Z':case robotDT of
              'N':robotT.Y:=robotT.Y+1;
              'D':robotT.Y:=robotT.Y-1;
              'L':robotT.x:=robotT.x+1;
              'R':robotT.x:=robotT.x-1;
            end;


          end;
            case gameMapa[robotT.x,robotT.y] of
          '^':robotT.y:=robotT.Y-1;
          'v':robotT.y:=robotT.Y+1;
          '<':robotT.x:=robotT.x-1;
          '>':robotT.x:=robotT.x+1;
          '#':begin if (displ=false) then showmessage('Robot by skonil v de'); displ:=true; end;
          'X':begin if (displ=false) then showmessage('Robot by skonil ve zdi'); displ:=true; end;
          '$':begin if (displ=false) then showmessage('Hur, zlato'); displ:=true; end;

          end;
         imageRedraw;
         drawMap;
         drawRobot(false);
      end;



    end;
end;

end.
